Part Module: Difference between revisions

From FreeCAD Documentation
(included Werner's excellent explanations from the forum)
(File:Part_ColorFace.svg, for the Part_ColorPerFace command.)
(179 intermediate revisions by 28 users not shown)
Line 1: Line 1:
<languages/>
== Introduction ==
<translate>
<!--T:52-->
{{Docnav
|[[OpenSCAD Module|OpenSCAD Module]]
|[[PartDesign Workbench|PartDesign Workbench]]
|IconL=Workbench_OpenSCAD.svg
|IconR=Workbench_PartDesign.svg
}}


<!--T:66-->
the CAD capabilities of FreeCAD are based on the [http://en.wikipedia.org/wiki/Open_CASCADE OpenCasCade] kernel. The Part module distinguishes between geometric primitives and (topological) shapes. A geometric primitive can be a point, a line, a circle, a plane, etc. or even some more complex types like a B-Spline curve or surface. In OpenCasCADE (OCC) dialect, a shape can be a vertex, an edge, a wire, a face, solid, a compound, etc.
[[Image:Workbench_Part.svg|thumb|128px|Part workbench icon]]
</translate>
{{TOCright}}
<translate>
== Introduction == <!--T:1-->
The solid modelling capabilities of FreeCAD are based on the [[OpenCASCADE|OpenCASCADE Technology]] (OCCT) kernel, a professional-grade CAD system that features advanced 3D geometry creation and manipulation. The [[Image:Workbench_Part.svg|24px]] [[Part Workbench|Part Workbench]] is a layer sitting on top of the OCCT libraries, that gives the user access to OCCT geometric primitives and functions. Essentially all 2D and 3D drawing functions in every workbench ([[Image:Workbench_Draft.svg|24px]] [[Draft Workbench|Draft]], [[Image:Workbench_Sketcher.svg|24px]] [[Sketcher Workbench|Sketcher]], [[Image:Workbench_PartDesign.svg|24px]] [[PartDesign Workbench|PartDesign]], etc.), are based on these functions exposed by the Part Workbench. Therefore, the Part Workbench is considered the core component of the modelling capabilities of FreeCAD.


<!--T:35-->
To get a complete list of all of them refer to the [http://www.opencascade.org/org/doc/ OCC documentation] and search for Geom_Geometry and TopoDS_Shape. There you can also read what are the differences between geometric objects and shapes. Please note that unfortunately the OCC documentation is not available online (you must download an archive) and is mostly aimed at programmers, not at end-users. But hopefully you'll find enough information to get started here.
The objects created with the Part Workbench are relatively simple; they are intended to be used with boolean operations (unions and cuts) in order to build more complex shapes. '''This modeling paradigm is known as the [[constructive solid geometry]] (CSG) workflow, and it was the traditional methodology used in early CAD systems.''' On the other hand, the [[PartDesign Workbench|PartDesign Workbench]] provides a more modern workflow to constructing shapes: it uses a parametrically defined sketch, that is extruded to form a basic solid body, which is then modified by parametric transformations ([[feature editing|feature editing]]), until the final object is obtained.


<!--T:54-->
The geometric types actually can be divided into two major groups: curves and surfaces. Out of the curves (line, circle, ...) you can directly build an edge, out of the surfaces (plane, cylinder, ...) a face can be built. For example, the geometric primitive line is unlimited, i.e. it is defined by a base vector and a direction vector while its shape representation must be something limited by a start and end point. And a box -- a solid -- can be created by six limited planes.
Part objects are more complex than mesh objects created with the [[Mesh Workbench|Mesh Workbench]], as they permit more advanced operations like coherent boolean operations, modifications history, and parametric behaviour.


</translate>
From an edge or face you can also go back to its geometric primitive counter part.
[[Image:Part_Workbench_relationships.svg|600px]]
<translate>


<!--T:55-->
Thus, out of shapes you can build very complex parts or, the other way round, extract all sub-shape a more complex shape is made of.
{{Caption|The Part Workbench is the basic layer that exposes the OCCT drawing functions to all workbenches in FreeCAD.}}


== Tools == <!--T:4-->
== User interface ==


<!--T:5-->
To create primitives from the user interface switch to the Part design workbench and click on 'Create primitives...' menu item under the Part menu. This opens a dialog where you are able to define the type of primitive and further properties depending on the type you have chosen. Then click on the 'Create' button to create such an element.
The tools are all located in the {{MenuCommand|Part}} menu.


===Primitives=== <!--T:6-->
The Part module is at the moment intended primarily to make its objects available to other parts of FreeCAD, so it has very few user interface elements on its own.


<!--T:36-->
== Scripting ==
These are tools for creating primitive objects.


<!--T:37-->
The main data structure used in the Part module is the [http://en.wikipedia.org/wiki/Boundary_representation BRep] data type from OpenCascade.
* [[Image:Part_Box.svg|32px]] [[Part_Box|Box]]: Draws a box by specifying its dimensions
About all contents and object types of the Part module are now available to python scripting. This includes geometric primitives, such as Line and Circle (or Arc), and the whole range of TopoShapes, like Vertexes, Edges, Wires, Faces, Solids and Compounds. For each of those objects, several creations methods exist, and for some of them, especially the TopoShapes, advanced operations like booleans union/difference/intersection are also available. Explore the contents of the Part module, as described in the [[FreeCAD Scripting Basics]] page, to know more.
* [[Image:Part_Cylinder.svg|32px]] [[Part_Cylinder|Cylinder]]: Draws a cylinder by specifying its dimensions
* [[Image:Part_Sphere.svg|32px]] [[Part_Sphere|Sphere]]: Draws a sphere by specifying its dimensions
* [[Image:Part_Cone.svg|32px]] [[Part_Cone|Cone]]: Draws a cone by specifying its dimensions
* [[Image:Part_Torus.svg|32px]] [[Part_Torus|Torus]]: Draws a torus (ring) by specifying its dimensions
* [[File:Part_Tube.svg|32px]] [[Part_Tube|Tube]]: draws a tube by specifying its internal radius and external radius. {{Version|0.19}}
* [[Image:Part_Primitives.svg|32px]] [[Part_Primitives|Primitives]]: A tool to add any of the defined geometric primitives.
* [[Image:Part_Shapebuilder.svg|32px]] [[Part_Builder|Shapebuilder]]: A tool to create more complex shapes from various parametric geometric primitives


===Modifying objects=== <!--T:38-->
== Examples ==


<!--T:39-->
To create a line element switch to the Python console and type in:
These are tools for modifying existing objects. They will allow you to choose which object to modify.


<!--T:40-->
<code python>
* [[Image:Part_Extrude.svg|32px]] [[Part_Extrude|Extrude]]: Extrudes planar faces of an object
import Part,PartGui
* [[Image:Part_Revolve.svg|32px]] [[Part_Revolve|Revolve]]: Creates a solid by revolving another object (not solid) around an axis
doc=App.newDocument()
* [[Image:Part_Mirror.svg|32px]] [[Part_Mirror|Mirror]]: Mirrors the selected object on a given mirror plane
# add a line element to the document and set its points
* [[Image:Part_Fillet.svg|32px]] [[Part_Fillet|Fillet]]: Fillets (rounds) edges of an object
l=Part.Line()
* [[Image:Part_Chamfer.svg|32px]] [[Part_Chamfer|Chamfer]]: Chamfers edges of an object
l.StartPoint=(0.0,0.0,0.0)
* [[Image:Part_RuledSurface.svg|32px]] [[Part_RuledSurface|Ruled Surface]]:
l.EndPoint=(1.0,1.0,1.0)
* [[Image:Part_Loft.svg|32px]] [[Part_Loft|Loft]]: Lofts from one profile to another
doc.addObject("Part::Feature","Line").Shape=l.toShape()
* [[Image:Part_Sweep.svg|32px]] [[Part_Sweep|Sweep]]: Sweeps one or more profiles along a path
doc.recompute()
</code>


<!--T:45-->
Let's go through the above python example step by step:
* [[Image:Part_CompOffsetTools.png|48px]] [[Part_CompOffsetTools|Offset tools]]:
** [[Image:Part_Offset.svg|32px]] [[Part_Offset|3D Offset]]: Constructs a parallel shape at a certain distance from original.
** [[Image:Part_Offset2D.svg|32px]] [[Part_Offset2D|2D Offset]]: Constructs a parallel wire at certain distance from original, or enlarges/shrinks a planar face. {{Version|0.17}}


<!--T:46-->
<code python>
* [[Image:Part_Thickness.svg|32px]] [[Part_Thickness|Thickness]]: Hollows out a solid, leaving openings next to select faces.
import Part,PartGui
doc=App.newDocument()
</code>


<!--T:57-->
loads the Part module and creates a new document
* [[File:Part_ProjectionOnSurface.svg|32px]] [[Part_ProjectionOnSurface|Projection on surface]]: Project a logo, text or any face,wire,edge to a surface. With the projection part it is possible to create a solid or wire. {{Version|0.19}}


<!--T:47-->
<code python>
* [[Image:Part_Compound.svg|48px]] [[Part_CompCompoundTools|Compound Tools]]:
l=Part.Line()
** [[Image:Part_Compound.svg|32px]] [[Part_Compound|Make compound]]: Creates a compound from the selected objects.
l.StartPoint=(0.0,0.0,0.0)
** [[Image:Part_ExplodeCompound.svg|32px]] [[Part_ExplodeCompound|Explode Compound]]: Tool to split up compounds of shapes
l.EndPoint=(1.0,1.0,1.0)
** [[Image:Part Compound‏‎Filter.svg|32px]] [[Part Compound‏‎Filter|Compound Filter]]: The CompoundFilter can be used to extract the individual pieces.
</code>


<!--T:48-->
Line is actually a line segment, hence the start and endpoint.
* [[Image:Part_Booleans.svg|32px]] [[Part_Boolean|Boolean]]: Performs boolean operations on objects
* [[Image:Part_Fuse.svg|32px]] [[Part_Union|Union]]: Fuses (unions) two objects
* [[Image:Part_Common.svg|32px]] [[Part_Common|Common]]: Extracts the common (intersection) part of two objects
* [[Image:Part_Cut.svg|32px]] [[Part_Cut|Cut]]: Cuts (subtracts) one object from another


<!--T:49-->
<code python>
* [[Image:Part_CompJoinFeatures.png|48px]] [[Part CompJoinFeatures|Join features]]: smart booleans for walled objects (e.g., pipes) {{Version|0.16}}
doc.addObject("Part::Feature","Line").Shape=l.toShape()
** [[Image:Part_JoinConnect.svg|32px]] [[Part_JoinConnect|Connect]]: Connects interiors of objects {{Version|0.16}}
</code>
** [[Image:Part_JoinEmbed.svg|32px]] [[Part_JoinEmbed|Embed]]: Embeds a walled object into another walled object {{Version|0.16}}
** [[Image:Part_JoinCutout.svg|32px]] [[Part_JoinCutout|Cutout]]: Creates a cutout in a wall of an object for another walled object {{Version|0.16}}


<!--T:50-->
This adds a Part object type to the document and assigns the shape representation of the line segment to the 'Shape' property of the added object. It is important to understand here that we used a geometric primitive (the Part.line) to create a TopoShape out of it (the toShape() method). Only Shapes can be added to the document. In FreeCAD, geometry primitives are used as "building structures" for Shapes.
* [[Image:Part_CompSplittingTools.png|48px]] [[Part CompSplittingTools|Splitting tools]]: {{Version|0.17}}
** [[Image:Part_BooleanFragments.svg|32px]] [[Part_BooleanFragments|Boolean fragments]]: makes all the pieces that can be obtained by Boolean operations between objects {{Version|0.17}}
** [[Image:Part SliceApart.svg|32px]] [[Part_SliceApart|Slice a part]]: tool to split shapes by intersection with other shapes
** [[Image:Part_Slice.svg|32px]] [[Part_Slice|Slice]]: Splits an object into pieces by intersections with another object {{Version|0.17}}
** [[Image:Part_XOR.svg|32px]] [[Part_XOR|XOR]]: removes space shared by even number of objects (symmetric version of [[Part_Cut|Cut]]) {{Version|0.17}}


<!--T:51-->
<code python>
* [[Image:Part Defeaturing.svg|32px]] [[Part_Defeaturing|Defeaturing]]: {{Version|0.18}}
doc.recompute()
* [[Image:Part_Section.svg|32px]] [[Part_Section|Section]]: Creates a section by intersecting an object with a section plane
</code>
* [[Image:Part_CrossSections.svg|32px]] [[Part_SectionCross|Cross sections...]]: Creates one or more cross-sections through a selected shape
* [[Image:Part Attachment.svg|32px]] [[Part Attachment|Attachment]]: attachment is a utility to attach an object to another one.


=== Measure === <!--T:58-->
Updates the document. This also prepare the visual representation of the new part object.


<!--T:59-->
Note that a Line can be created by specifiying its start and endpoint directly in the constructor, for ex. Part.Line(point1,point2) or we can create a default line and set its properties afterwards, like we did here.
[[File:Part Measure Menu.png|64px]] [[Part Measure Menu|Measure]]: Allows linear and angular measurement between points, edges, and faces.


<!--T:60-->
A circle can be created in a similar way:
* [[Image:Part_Measure_Linear.svg|32px]] [[Part_Measure_Linear|Measure Linear]] allows you to make linear measurements.
* [[Image:Part_Measure_Angular.svg|32px]] [[Part_Measure_Angular|Measure Angular]] allows you to make angular measurements.
* [[Image:Part_Measure_Refresh.svg|32px]] [[Part_Measure_Refresh|Measure Refresh]] updates the measurements on screen.
* [[Image:Part_Measure_Clear_All.svg|32px]] [[Part_Measure_Clear_All|Clear All]] Clears all measurements.
* [[Image:Part_Measure_Toggle_All.svg|32px]] [[Part_Measure_Toggle_All|Toggle All]] shows or hides all measurements.
* [[Image:Part_Measure_Toggle_3d.svg|32px]] [[Part_Measure_Toggle_3d|Toggle 3D]] shows or hides 3D measurements.
* [[Image:Part_Measure_Toggle_Delta.svg|32px]] [[Part_Measure_Toggle_Delta|Toggle Delta]] shows or hides delta measurements.


===Other tools=== <!--T:41-->
<code python>
import Part
doc = App.activeDocument()
c = Part.Circle()
c.Radius=10.0
f = doc.addObject("Part::Feature", "Circle")
f.Shape = c.toShape()
doc.recompute()
</code>


<!--T:42-->
Note again, we used the circle (geometry primitive) to construct a shape out of it. We can of course still access our construction geometry afterwards, by doing:
* [[Image:Part_Import.svg|32px]] [[Part Import|Import]]: This tool allows you to add a file *.IGES, *.STEP, *.BREP to the current document.
* [[Image:Part_Export.svg|32px]] [[Part Export|Export]]: This tool allows you to export a part object in a *.IGES, *.STEP, *.BREP file.
* [[File:Part_BoxSelection.svg|32px]] [[Part_BoxSelection|BoxSelection]]: add to the selection the faces of the shapes that are touches by the rectangular selection. {{Version|0.19}}
* [[Image:Part_ShapeFromMesh.svg|32px]] [[Part ShapeFromMesh|Shape from Mesh]]: Creates a shape object from a mesh object.
* [[File:Part_PointsFromMesh.svg|32px]] [[Part PointsFromMesh|Points from mesh]]: creates a shape object made of points from the mesh. {{Version|0.19}}
* [[Part_MakeSolid|Convert to solid]]: Converts a shape object to a solid object.
* [[File:Part_ReverseShapes.svg|32px]] [[Part_ReverseShapes|Reverse shapes]]: Flips the normals of all faces of the selected object.


<!--T:61-->
<code python>
* Create a copy:
s = f.Shape
** [[Image:Part_SimpleCopy‎.svg|32px]] [[Part_SimpleCopy|Create simple copy]]: Creates a simple copy of the selected object.
e = s.Edges[0]
** [[File:Part_TransformedCopy.svg|32px]] [[Part_TransformedCopy|Create transformed copy]]: creates a transformed copy of the selected object. {{Version|0.19}}
c = e.Curve
** [[File:Part_ElementCopy.svg|32px]] [[Part_ElementCopy|Create shape element copy]]: creates a copy from an element (vertex, edge, face) of the selected object. {{Version|0.19}}
</code>
** [[Image:Part_RefineShape.svg|32px]] [[Part_RefineShape|Refine shape]]: Cleans faces by removing unnecessary lines.


<!--T:62-->
Here we take the shape of our object f, then we take its list of edges, in this case there will be only one because we made the whole shape out of a single circle, so we take only the first item of the Edges list, and we takes its curve. Every Edge has a Curve, which is the geometry primitive it is based on.
* [[Image:Part_CheckGeometry.svg|32px]] [[Part CheckGeometry|Check geometry]]: Checks the geometry of selected objects for errors.


=== Context menu items === <!--T:80-->
Head to the [[Topological data scripting]] page if you would like to know more.

<!--T:81-->
*[[Std_SetAppearance|Appearance]]: determines appearance of the whole part (color transparency etc.).
* [[File:Part_ColorFace.svg|32px]] [[Part_FaceColors|Set colors]]: assigns colors to part faces.

== Preferences == <!--T:43-->

<!--T:44-->
<!--The PartDesign preferences are defined in the Part workbench and both the PartDesign workbench and the Part workbench use them-->
* [[Image:Preferences-part_design.svg|32px]] [[PartDesign_Preferences|Preferences]]: preferences available for Part Tools (the Part workbench also uses the PartDesign Preferences).
* [[Image:Preferences-import-export.svg|32px]] [[Import_Export_Preferences|Import Export Preferences]]: preferences available for importing from and exporting to different file formats.
* [[Fine-tuning]]: some extra parameters to fine-tune Part behavior.

== Scripting == <!--T:18-->

<!--T:56-->
See [[Part scripting|Part scripting]].

== Tutorials == <!--T:34-->

<!--T:82-->
* [[Import_from_STL_or_OBJ|Import from STL or OBJ]] : How to import STL/OBJ files in FreeCAD
* [[Export_to_STL_or_OBJ|Export to STL or OBJ]] : How to export STL/OBJ files from FreeCAD
* [[Whiffle_Ball_tutorial|Whiffle Ball tutorial]] : How to use the Part Module


<!--T:32-->
{{Docnav
|[[OpenSCAD Module|OpenSCAD Module]]
|[[PartDesign Workbench|PartDesign Workbench]]
|IconL=Workbench_OpenSCAD.svg
|IconR=Workbench_PartDesign.svg
}}

</translate>
{{Part Tools navi{{#translation:}}}}
{{Userdocnavi{{#translation:}}}}
[[Category:Workbenches{{#translation:}}]]

Revision as of 00:21, 12 October 2020

Part workbench icon

Introduction

The solid modelling capabilities of FreeCAD are based on the OpenCASCADE Technology (OCCT) kernel, a professional-grade CAD system that features advanced 3D geometry creation and manipulation. The Part Workbench is a layer sitting on top of the OCCT libraries, that gives the user access to OCCT geometric primitives and functions. Essentially all 2D and 3D drawing functions in every workbench ( Draft, Sketcher, PartDesign, etc.), are based on these functions exposed by the Part Workbench. Therefore, the Part Workbench is considered the core component of the modelling capabilities of FreeCAD.

The objects created with the Part Workbench are relatively simple; they are intended to be used with boolean operations (unions and cuts) in order to build more complex shapes. This modeling paradigm is known as the constructive solid geometry (CSG) workflow, and it was the traditional methodology used in early CAD systems. On the other hand, the PartDesign Workbench provides a more modern workflow to constructing shapes: it uses a parametrically defined sketch, that is extruded to form a basic solid body, which is then modified by parametric transformations (feature editing), until the final object is obtained.

Part objects are more complex than mesh objects created with the Mesh Workbench, as they permit more advanced operations like coherent boolean operations, modifications history, and parametric behaviour.

The Part Workbench is the basic layer that exposes the OCCT drawing functions to all workbenches in FreeCAD.

Tools

The tools are all located in the Part menu.

Primitives

These are tools for creating primitive objects.

  • Box: Draws a box by specifying its dimensions
  • Cylinder: Draws a cylinder by specifying its dimensions
  • Sphere: Draws a sphere by specifying its dimensions
  • Cone: Draws a cone by specifying its dimensions
  • Torus: Draws a torus (ring) by specifying its dimensions
  • Tube: draws a tube by specifying its internal radius and external radius. introduced in version 0.19
  • Primitives: A tool to add any of the defined geometric primitives.
  • Shapebuilder: A tool to create more complex shapes from various parametric geometric primitives

Modifying objects

These are tools for modifying existing objects. They will allow you to choose which object to modify.

  • Extrude: Extrudes planar faces of an object
  • Revolve: Creates a solid by revolving another object (not solid) around an axis
  • Mirror: Mirrors the selected object on a given mirror plane
  • Fillet: Fillets (rounds) edges of an object
  • Chamfer: Chamfers edges of an object
  • Ruled Surface:
  • Loft: Lofts from one profile to another
  • Sweep: Sweeps one or more profiles along a path
  • Thickness: Hollows out a solid, leaving openings next to select faces.
  • Boolean: Performs boolean operations on objects
  • Union: Fuses (unions) two objects
  • Common: Extracts the common (intersection) part of two objects
  • Cut: Cuts (subtracts) one object from another

Measure

File:Part Measure Menu.png Measure: Allows linear and angular measurement between points, edges, and faces.

Other tools

Context menu items

  • Appearance: determines appearance of the whole part (color transparency etc.).
  • Set colors: assigns colors to part faces.

Preferences

  • Preferences: preferences available for Part Tools (the Part workbench also uses the PartDesign Preferences).
  • Import Export Preferences: preferences available for importing from and exporting to different file formats.
  • Fine-tuning: some extra parameters to fine-tune Part behavior.

Scripting

See Part scripting.

Tutorials